%script de comprobacin de la prantica 4
%script para comprobacin de la prctica 2
%Mensaje general de las prcticas
input('Pulsa una tecla para continuar la ejecucin');
warning off all;
close all;
nombreImagen = 'lenna256.bmp';

%Caso 1*******************************************************
%**************************************************************
    senal=imread(nombreImagen,'bmp');
    n = 8;
    [Perror] = DCT_N(senal,n);
    disp('Procesando caso1:**************************************');
    disp('Comprobando DCT_N')
    close all;
    PerrorCorrecta = 15565234;
    precisionError = PerrorCorrecta/10000;
    %Obtengo imgenes correctas
    %imCorrectaDCT = imread('imagendctCaso1DCT_N.bmp');
    imCorrectaDeco = imread('imagendecoCaso1DCT_N.bmp');
    imCorrectaError = imread('imagenerrorCaso1DCT_N.bmp');
    %Obtengo imgenes resultantes de esta ejecucion
    %imDCT = imread('imagendct.bmp');
    imDeco = imread('imagendeco.bmp');
    imCError = imread('imagenerror.bmp');
    
    
    %Compruebo ls resultados Este cdigo est comentado debido a que al
    %escribir la imagen DCT y volverla a leer se prodicen prdidas.
%     [flagSize,flagEquality] = comparaMatrices(imCorrectaDCT,imDCT);
%     if flagSize
%         mensaje = ['Error en las dimensiones de la imagen DCT'];
%         error2(mensaje);
%     end
%     if flagEquality
%        mensaje = ['Error en la imagen DCT'];
%         error2(mensaje);
%     end
    
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaDeco,imDeco);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen deco'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen deco'];
        error2(mensaje);
    end
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaError,imCError);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen error'];
        error2(mensaje);
    end
    
    [flagSize,flagEquality] = comparaMatricesReales(PerrorCorrecta,Perror,precisionError);
    if flagSize
        mensaje = ['Error en las dimensiones de la potencia de error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la potencia de error'];
        error2(mensaje);
    end
     
   disp('  DCT_N BIEN');
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
   
   
   disp('Comprobando cuantif_N')
   [Perror] = cuantif_N(senal,n);
   close all;
    PerrorCorrecta = 9016;
    precisionError = PerrorCorrecta/10000;
    %Obtengo imgenes correctas
    imCorrectaDeco = imread('imagendecoCaso1cuantif_N.bmp');
    imCorrectaError = imread('imagenerrorCaso1cuantif_N.bmp');
    %Obtengo imgenes resultantes de esta ejecucion
    imDeco = imread('imagendeco.bmp');
    imCError = imread('imagenerror.bmp');
    
    
    %Compruebo ls resultados
     
    [flagSize,flagEquality] = comparaMatrices(imCorrectaDeco,imDeco);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen deco'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen deco'];
        error2(mensaje);
    end
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaError,imCError);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen error'];
        error2(mensaje);
    end
    
    [flagSize,flagEquality] = comparaMatricesReales(PerrorCorrecta,Perror,precisionError);
    if flagSize
        mensaje = ['Error en las dimensiones de la potencia de error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la potencia de error'];
        error2(mensaje);
    end
   disp('  cuantif_N BIEN');
   
 %Caso 2*******************************************************
%**************************************************************
    senal=imread(nombreImagen,'bmp');
    n = 4;
    [Perror] = DCT_N(senal,n);
    disp('Procesando caso2:**************************************');
    disp('Comprobando DCT_N')
    close all;
    PerrorCorrecta = 3.4365e+009;
     precisionError = PerrorCorrecta/10000;
    %Obtengo imgenes correctas
    %imCorrectaDCT = imread('imagendctCaso2DCT_N.bmp');
    imCorrectaDeco = imread('imagendecoCaso2DCT_N.bmp');
    imCorrectaError = imread('imagenerrorCaso2DCT_N.bmp');
    %Obtengo imgenes resultantes de esta ejecucion
    %imDCT = imread('imagendct.bmp');
    imDeco = imread('imagendeco.bmp');
    imCError = imread('imagenerror.bmp');
    
    
    %Compruebo ls resultados
%     [flagSize,flagEquality] = comparaMatrices(imCorrectaDCT,imDCT);
%     if flagSize
%         mensaje = ['Error en las dimensiones de la imagen DCT'];
%         error2(mensaje);
%     end
%     if flagEquality
%        mensaje = ['Error en la imagen DCT'];
%         error2(mensaje);
%     end
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaDeco,imDeco);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen deco'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen deco'];
        error2(mensaje);
    end
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaError,imCError);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen error'];
        error2(mensaje);
    end
    [flagSize,flagEquality] = comparaMatricesReales(PerrorCorrecta,Perror,precisionError);
    if flagSize
        mensaje = ['Error en las dimensiones de la potencia de error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la potencia de error'];
        error2(mensaje);
    end
   disp('  DCT_N BIEN');
   
   disp('Comprobando cuantif_N')
   [Perror] = cuantif_N(senal,n);
   close all;
   PerrorCorrecta = 1699029;
   precisionError = PerrorCorrecta/10000;
    %Obtengo imgenes correctas
    imCorrectaDeco = imread('imagendecoCaso2cuantif_N.bmp');
    imCorrectaError = imread('imagenerrorCaso2cuantif_N.bmp');
    %Obtengo imgenes resultantes de esta ejecucion
    imDeco = imread('imagendeco.bmp');
    imCError = imread('imagenerror.bmp');
    
    
    %Compruebo ls resultados
     
    [flagSize,flagEquality] = comparaMatrices(imCorrectaDeco,imDeco);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen deco'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen deco'];
        error2(mensaje);
    end
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaError,imCError);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen error'];
        error2(mensaje);
    end
     [flagSize,flagEquality] = comparaMatricesReales(PerrorCorrecta,Perror, precisionError);
    if flagSize
        mensaje = ['Error en las dimensiones de la potencia de error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la potencia de error'];
        error2(mensaje);
    end
   disp('  cuantif_N BIEN');
   
   %Caso 3*******************************************************
%**************************************************************
nombreImagen = 'lenna96.bmp';
    senal=imread(nombreImagen,'bmp');
    n = 4;
    disp('Procesando caso3:**************************************');
    disp('Comprobando DCT_N')
    [Perror] = DCT_N(senal,n);
    close all;
    PerrorCorrecta = 448406510;
    precisionError = PerrorCorrecta/10000;
    %Obtengo imgenes correctas
    %imCorrectaDCT = imread('imagendctCaso3DCT_N.bmp');
    imCorrectaDeco = imread('imagendecoCaso3DCT_N.bmp');
    imCorrectaError = imread('imagenerrorCaso3DCT_N.bmp');
    %Obtengo imgenes resultantes de esta ejecucion
    %imDCT = imread('imagendct.bmp');
    imDeco = imread('imagendeco.bmp');
    imCError = imread('imagenerror.bmp');
    
    
    %Compruebo ls resultados
%     [flagSize,flagEquality] = comparaMatrices(imCorrectaDCT,imDCT);
%     if flagSize
%         mensaje = ['Error en las dimensiones de la imagen DCT'];
%         error2(mensaje);
%     end
%     if flagEquality
%        mensaje = ['Error en la imagen DCT'];
%         error2(mensaje);
%     end
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaDeco,imDeco);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen deco'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen deco'];
        error2(mensaje);
    end
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaError,imCError);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen error'];
        error2(mensaje);
    end
    [flagSize,flagEquality] = comparaMatricesReales(PerrorCorrecta,Perror, precisionError);
    if flagSize
        mensaje = ['Error en las dimensiones de la potencia de error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la potencia de error'];
        error2(mensaje);
    end
   disp('  DCT_N BIEN');
   
   disp('Comprobando cuantif_N')
   [Perror] = cuantif_N(senal,n);
   close all;
   PerrorCorrecta = 332390;
    precisionError = PerrorCorrecta/10000;
    %Obtengo imgenes correctas
    imCorrectaDeco = imread('imagendecoCaso3cuantif_N.bmp');
    imCorrectaError = imread('imagenerrorCaso3cuantif_N.bmp');
    %Obtengo imgenes resultantes de esta ejecucion
    imDeco = imread('imagendeco.bmp');
    imCError = imread('imagenerror.bmp');
    
    
    %Compruebo ls resultados
     
    [flagSize,flagEquality] = comparaMatrices(imCorrectaDeco,imDeco);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen deco'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen deco'];
        error2(mensaje);
    end
    
    [flagSize,flagEquality] = comparaMatrices(imCorrectaError,imCError);
    if flagSize
        mensaje = ['Error en las dimensiones de la imagen error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la imagen error'];
        error2(mensaje);
    end
         [flagSize,flagEquality] = comparaMatricesReales(PerrorCorrecta,Perror, precisionError);
    if flagSize
        mensaje = ['Error en las dimensiones de la potencia de error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la potencia de error'];
        error2(mensaje);
    end
   disp('  cuantif_N BIEN');