%scriptTestDCT_basica_imagen
DCT_basica;
disp('Comprobando el script DCT_basica.m***********************************************')
%Imgenes correctas (matriz A)
imBloquesCorrecta = imread('imagenbloquesAcorrecta.bmp');
%imdctCorrecta = imread('imagendctAcorrecta.bmp');
imDecoCorrecta = imread('imagendecoAcorrecta.bmp');
imErrorCorrecta = imread('imagenerrorAcorrecta.bmp');
%Imgenes resultantes (matriz A)
imBloques = imread('imagenbloques.bmp');
%imdct = imread('imagendct.bmp');
imDeco = imread('imagendeco.bmp');
imError = imread('imagenerror.bmp');

%Compruebo los resultados
[flagSize,flagEquality] = comparaMatrices(imBloquesCorrecta,imBloques);
if flagSize
    mensaje = ['Error en las dimensiones de la imgen de bloques'];
    error2(mensaje);
end
if flagEquality
   mensaje = ['Error en la imgen de bloques'];
    error2(mensaje);
end

% [flagSize,flagEquality] = comparaMatrices(imdctCorrecta,imdct);
% if flagSize
%     mensaje = ['Error en las dimensiones de la imagen DCT'];
%     error2(mensaje);
% end
% if flagEquality
%    mensaje = ['Error en la imagen DCT'];
%     error2(mensaje);
% end
[flagSize,flagEquality] = comparaMatrices(imDecoCorrecta,imDeco);
if flagSize
    mensaje = ['Error en las dimensiones de la imagen decodificada'];
    error2(mensaje);
end
if flagEquality
   mensaje = ['Error en la imagen decodificada'];
    error2(mensaje);
end
[flagSize,flagEquality] = comparaMatrices(imErrorCorrecta,imError);
if flagSize
    mensaje = ['Error en las dimensiones de la imagen de error'];
    error2(mensaje);
end
if flagEquality
   mensaje = ['Error en la imagen de error'];
    error2(mensaje);
end
disp('Script DCT_basica.m       BIEN');

input('Pulsa una tecla para continuar la ejecucin');
imagen = imread('lenna256.bmp','bmp');
[Perror] = DCT_Imagen(imagen);
disp('Comprobando la funcin DCT_imagen.m para lenna256.bmp**********************')
%Imgenes correctas (Lenna256)
PerrorCorrecta = 2183059;
    precisionError = PerrorCorrecta/10000;
imBloquesCorrecta = imread('imagenbloquesImagencorrecta.bmp');
%imdctCorrecta = imread('imagendctImagencorrecta.bmp');
imDecoCorrecta = imread('imagendecoImagencorrecta.bmp');
imErrorCorrecta = imread('imagenerrorImagencorrecta.bmp');
%Imgenes resultantes (Lenna256)
imBloques = imread('imagenbloques.bmp');
%imdct = imread('imagendct.bmp');
imDeco = imread('imagendeco.bmp');
imError = imread('imagenerror.bmp');

%Compruebo los resultados
[flagSize,flagEquality] = comparaMatrices(imBloquesCorrecta,imBloques);
if flagSize
    mensaje = ['Error en las dimensiones de la imgen de bloques'];
    error2(mensaje);
end
if flagEquality
   mensaje = ['Error en la imgen de bloques'];
    error2(mensaje);
end

% [flagSize,flagEquality] = comparaMatrices(imdctCorrecta,imdct);
% if flagSize
%     mensaje = ['Error en las dimensiones de la imagen DCT'];
%     error2(mensaje);
% end
% if flagEquality
%    mensaje = ['Error en la imagen DCT'];
%     error2(mensaje);
% end
[flagSize,flagEquality] = comparaMatrices(imDecoCorrecta,imDeco);
if flagSize
    mensaje = ['Error en las dimensiones de la imagen decodificada'];
    error2(mensaje);
end
if flagEquality
   mensaje = ['Error en la imagen decodificada'];
    error2(mensaje);
end
[flagSize,flagEquality] = comparaMatrices(imErrorCorrecta,imError);
if flagSize
    mensaje = ['Error en las dimensiones de la imagen de error'];
    error2(mensaje);
end
if flagEquality
   mensaje = ['Error en la imagen de error'];
    error2(mensaje);
end


 [flagSize,flagEquality] = comparaMatricesReales(PerrorCorrecta,Perror,precisionError);
    if flagSize
        mensaje = ['Error en las dimensiones de la potencia de error'];
        error2(mensaje);
    end
    if flagEquality
       mensaje = ['Error en la potencia de error'];
        error2(mensaje);
    end
disp('Script DCT_Imagen.m       BIEN');
